import scala.actors.Actor

//object PingPongMain extends App {
object PingPongMain {
  def main(args: Array[String]) {
    val pong = new PingPong(null, "pong");
    val ping = new PingPong(pong, "ping");

    ping.start();
    pong.start();

    ping ! "foo";
  }
}

class PingPong(sendTo: Actor, val name: String) extends Actor
{
  def act() {
    loop {
      react {
        case (i: Int) => {
          println(name + " received " + i)
          if (sendTo != null)
            sendTo ! i+1
          else
            sender ! i+1
        }
        case _ => {
          if (sendTo != null)
            sendTo ! "bar"
          else
            sender ! "bar"
          exit()
        }
      }
    }
  }
}
